Codeforces 677C. Coloring Trees dp

时间:2023-11-28 23:46:14
C. Coloring Trees
time limit per test:2 seconds
memory limit per test:256 megabytes
input:standard input
output:standard output

ZS the Coder and Chris the Baboon has arrived at Udayland! They walked in the park where n trees grow. They decided to be naughty and color the trees in the park. The trees are numbered with integers from 1 to n from left to right.

Initially, tree i has color ci. ZS the Coder and Chris the Baboon recognizes only m different colors, so 0 ≤ ci ≤ m, where ci = 0 means that tree i is uncolored.

ZS the Coder and Chris the Baboon decides to color only the uncolored trees, i.e. the trees with ci = 0. They can color each of them them in any of the m colors from 1 to m. Coloring the i-th tree with color j requires exactly pi, j litres of paint.

The two friends define the beauty of a coloring of the trees as the minimum number of contiguous groups (each group contains some subsegment of trees) you can split all the n trees into so that each group contains trees of the same color. For example, if the colors of the trees from left to right are 2, 1, 1, 1, 3, 2, 2, 3, 1, 3, the beauty of the coloring is 7, since we can partition the trees into 7 contiguous groups of the same color : {2}, {1, 1, 1}, {3}, {2, 2}, {3}, {1}, {3}.

ZS the Coder and Chris the Baboon wants to color all uncolored trees so that the beauty of the coloring is exactly k. They need your help to determine the minimum amount of paint (in litres) needed to finish the job.

Please note that the friends can't color the trees that are already colored.

Input

The first line contains three integers, n, m and k (1 ≤ k ≤ n ≤ 100, 1 ≤ m ≤ 100) — the number of trees, number of colors and beauty of the resulting coloring respectively.

The second line contains n integers c1, c2, ..., cn (0 ≤ ci ≤ m), the initial colors of the trees. ci equals to 0 if the tree number i is uncolored, otherwise the i-th tree has color ci.

Then n lines follow. Each of them contains m integers. The j-th number on the i-th of them line denotes pi, j (1 ≤ pi, j ≤ 109) — the amount of litres the friends need to color i-th tree with color j. pi, j's are specified even for the initially colored trees, but such trees still can't be colored.

Output

Print a single integer, the minimum amount of paint needed to color the trees. If there are no valid tree colorings of beauty k, print  - 1.

Examples
Input
3 2 2
0 0 0
1 2
3 4
5 6
Output
10
Input
3 2 2
2 1 2
1 3
2 4
3 5
Output
-1
Input
3 2 2
2 0 0
1 3
2 4
3 5
Output
5
Input
3 2 3
2 1 2
1 3
2 4
3 5
Output
0
Note

In the first sample case, coloring the trees with colors 2, 1, 1 minimizes the amount of paint used, which equals to 2 + 3 + 5 = 10. Note that 1, 1, 1 would not be valid because the beauty of such coloring equals to 1 ({1, 1, 1} is a way to group the trees into a single group of the same color).

In the second sample case, all the trees are colored, but the beauty of the coloring is 3, so there is no valid coloring, and the answer is  - 1.

In the last sample case, all the trees are colored and the beauty of the coloring matches k, so no paint is used and the answer is 0.

题目连接:http://codeforces.com/contest/711/problem/C


题意:有n棵树,m种染料。从1到n给未染色的树染色。第i棵树染第ci种色。ci=0表示第i棵树未染色。pi,j表示第i棵树染第j种颜色需要花费的价值。求出1到n全部染色需要花费最少的价值,必须保证有k段颜色。

思路:动态规划。dp[i][j][t]表示前i棵树,第i棵树染第j中染色,有t段颜色的最少花费。如果当前选择的颜色与上一棵树的不同t+1,相同t不变。


代码:

 #include<iostream>
#include<cstdio>
using namespace std;
const __int64 INF=1e12;
__int64 c[],p[][],dp[][][];
int main()
{
int i,j,t,h,n,m,k;
scanf("%d%d%d",&n,&m,&k);
for(i=; i<=n; i++) scanf("%I64d",&c[i]);
for(i=; i<=n; i++)
for(j=; j<=m; j++)
scanf("%I64d",&p[i][j]);
if(k>n)
{
cout<<"-1"<<endl;
return ;
}
for(i=; i<=n; i++)
for(j=; j<=m; j++)
for(t=; t<=n; t++)
dp[i][j][t]=INF;
if(c[]==)
for(j=; j<=m; j++)
dp[][j][]=p[][j];
else dp[][c[]][]=;
for(i=; i<=n; i++)
{
if(c[i]==)
{
for(j=; j<=m; j++)
for(t=; t<=i; t++)
for(h=; h<=m; h++)
{
if(j==h)
dp[i][j][t]=min(dp[i][j][t],dp[i-][h][t]+p[i][j]);
else
dp[i][j][t]=min(dp[i][j][t],dp[i-][h][t-]+p[i][j]);
}
}
else
{
for(t=; t<=i; t++)
for(h=; h<=m; h++)
{
if(c[i]==h)
dp[i][c[i]][t]=min(dp[i][c[i]][t],dp[i-][h][t]);
else
dp[i][c[i]][t]=min(dp[i][c[i]][t],dp[i-][h][t-]);
}
}
}
__int64 ans=INF;
for(j=; j<=m; j++)
ans=min(ans,dp[n][j][k]);
if(ans==INF) cout<<"-1"<<endl;
else printf("%I64d\n",ans);
return ;
}